Index: /pjproject/trunk/pjsip/include/pjsip/sip_uri.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 126)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_uri.h	(revision 127)
@@ -162,7 +162,7 @@
      * @return the length printed.
      */
-    int	(*p_print)(pjsip_uri_context_e context,
-		   const void *uri, 
-		   char *buf, pj_size_t size);
+    pj_ssize_t (*p_print)(pjsip_uri_context_e context,
+			  const void *uri, 
+		          char *buf, pj_size_t size);
 
     /** 
@@ -333,5 +333,5 @@
  * @return SIP URL.
  */
-PJ_DECL(pjsip_sip_uri*) pjsip_url_create( pj_pool_t *pool, int secure );
+PJ_DECL(pjsip_sip_uri*) pjsip_sip_uri_create( pj_pool_t *pool, int secure );
 
 /**
@@ -340,5 +340,5 @@
  * @return	    SIPS URL.
  */
-PJ_DECL(pjsip_sip_uri*) pjsips_url_create( pj_pool_t *pool );
+PJ_DECL(pjsip_sip_uri*) pjsip_sips_uri_create( pj_pool_t *pool );
 
 /**
@@ -346,5 +346,5 @@
  * @param url	    The URL.
  */
-PJ_DECL(void)  pjsip_url_init(pjsip_sip_uri *url, int secure);
+PJ_DECL(void)  pjsip_sip_uri_init(pjsip_sip_uri *url, int secure);
 
 /**
@@ -354,6 +354,6 @@
  * @param rhs	    The source URL.
  */
-PJ_DECL(void)  pjsip_url_assign(pj_pool_t *pool, pjsip_sip_uri *url, 
-				const pjsip_sip_uri *rhs);
+PJ_DECL(void)  pjsip_sip_uri_assign(pj_pool_t *pool, pjsip_sip_uri *url, 
+				    const pjsip_sip_uri *rhs);
 
 /**
Index: /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 126)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 127)
@@ -349,4 +349,40 @@
     sess->cred_info = NULL;
     pj_list_init(&sess->cached_auth);
+
+    return PJ_SUCCESS;
+}
+
+
+/* Clone session. */
+PJ_DEF(pj_status_t) pjsip_auth_clt_clone( pj_pool_t *pool,
+					  pjsip_auth_clt_sess *sess,
+					  const pjsip_auth_clt_sess *rhs )
+{
+    unsigned i;
+
+    PJ_ASSERT_RETURN(pool && sess && rhs, PJ_EINVAL);
+
+    sess->pool = pool;
+    sess->endpt = (pjsip_endpoint*)rhs->endpt;
+    sess->cred_cnt = rhs->cred_cnt;
+    sess->cred_info = pj_pool_alloc(pool, 
+				    sess->cred_cnt*sizeof(pjsip_cred_info));
+    for (i=0; i<rhs->cred_cnt; ++i) {
+	pj_strdup(pool, &sess->cred_info[i].realm, &rhs->cred_info[i].realm);
+	pj_strdup(pool, &sess->cred_info[i].scheme, &rhs->cred_info[i].scheme);
+	pj_strdup(pool, &sess->cred_info[i].username, 
+		  &rhs->cred_info[i].username);
+	sess->cred_info[i].data_type = rhs->cred_info[i].data_type;
+	pj_strdup(pool, &sess->cred_info[i].data, &rhs->cred_info[i].data);
+    }
+
+    /* TODO note:
+     * Cloning the full authentication client is quite a big task.
+     * We do only the necessary bits here, i.e. cloning the credentials.
+     * The drawback of this basic approach is, a forked dialog will have to
+     * re-authenticate itself on the next request because it has lost the
+     * cached authentication headers.
+     */
+    PJ_TODO(FULL_CLONE_OF_AUTH_CLIENT_SESSION);
 
     return PJ_SUCCESS;
